//***Please open "210415_14_1040-10.tif" before starting this macro***
makeRectangle(177, 50, 60, 60);
run("Duplicate...", "title=RGOstack duplicate");

//Background subtraction, parameters were determined in the associated Excel file
getDimensions(width, height, channels, slices, frames);
for (i = 0; i < slices; i++) {
	lp = i+2; //laser power (%)
	//round 1, Red channel (Ch1)
	setSlice(i*3 + 1);
	bkg = 155.6 + 0.082*lp;
	run("Subtract...", "value=" + bkg + " slice");
	//round 2, Orange channel (Ch3)
	setSlice(i*3 + 3);
	bkg = 137.1 + 0.946*lp;
	run("Subtract...", "value=" + bkg + " slice");
}

//Duplicate Red and Orange channels
run("Duplicate...", "title=RCh duplicate channels=1");
selectWindow("RGOstack");
run("Duplicate...", "title=OCh duplicate channels=3");
selectWindow("RGOstack");close();

//Make montage
newImage("Separator", "16-bit black", 60, 2, 7);
run("Add...", "value=4095 stack");
run("Combine...", "stack1=OCh stack2=Separator combine");
run("Combine...", "stack1=[Combined Stacks] stack2=RCh combine");
run("Make Montage...", "columns=7 rows=1 scale=1 border=2");
run("Grays");
setMinAndMax(0, 600);
run("Rotate 90 Degrees Right");
rename("Fig2SB.tif")

//Close unnecessary window
selectWindow("Combined Stacks");close();
